#include <set>
#include <vector>
using namespace std;

#include <snbfrx.h>
using namespace snbfrx;

#include "simpleentity.h"
#include "simpleentityfactory.h"

// simple sample showing basic usage of the entity manager...
void main()
{
    // get instance of singleton EntityManager.
    EntityManager* em = EntityManager::getInstance();
    
    // instantiate SimpleEntityFactory
    SimpleEntityFactory factory( 10 );
    
    // register SimpleEntityFactory
    em->registerFactory( factory.getName(), &factory );

    // insert 10 entities into entity manager.
    for( int i = 0; i < 10; i ++ )    
        em->addEntity( factory.createEntity() );
    
    // get active entity set
    const set<Entity*>& entities = em->getEntities();

    // while there are entities in the set...
    while( entities.size() != 0 )
    {
        // update and render all active entities.
        em->update();
        em->render();
    }

    // delte manager.
    delete em;
}