#include <string>
#include <vector>
using namespace std;

#include <snbfrx.h>
using namespace snbfrx;

#include "simpleentity.h"
#include "simpleentityfactory.h"

SimpleEntityFactory::SimpleEntityFactory( int poolsize )
{
    // sets up name and description.
    setName( string( "SimpleEntityFactory" ) );
    setDescription( string( "SimpleEntityFactory" ) );

    // creates entities for the pool.
    for( int i = 0; i < poolsize; i ++ )
        m_freeEntity.push_back( new SimpleEntity( i, this ) );
}

SimpleEntityFactory::~SimpleEntityFactory()
{
    // delete all used entities
    for( set<SimpleEntity*>::iterator it = m_usedEntity.begin(); it!= m_usedEntity.end(); it ++ )
    {
        SimpleEntity* pentity = *it;
        delete pentity;
    }

    // delete all free entities
    for( vector<SimpleEntity*>::iterator it = m_freeEntity.begin(); it!= m_freeEntity.end(); it ++ )
    {
        SimpleEntity* pentity = *it;
        delete pentity;
    }
}

Entity* SimpleEntityFactory::createEntity()
{
    SimpleEntity* pentity = NULL;
    
    // check if there are any freen entities..
    if( m_freeEntity.size() != 0 )
    {
        // free entity found.
        pentity = m_freeEntity.back();

        // pop entity off of free entity vector.
        m_freeEntity.pop_back();

        // add entity to used set.
        m_usedEntity.insert( pentity );
    }
    
    // reset values of entity.
    pentity->reset();

    // return new entity.
    return pentity;
}

void SimpleEntityFactory::releaseEntity( Entity* pentity )
{
    // remove entity from the used set.
    m_usedEntity.erase( (SimpleEntity*) pentity );

    // push the entit back on the free entity list.
    m_freeEntity.push_back( (SimpleEntity*) pentity );    
}
